#include <mask.h>
#include <form.h>
#include <printapp.h>

#include "lf.h"
#include "soggetti.h"
#include "sezioni.h"
#include <comuni.h>

#include "at2.h"
#include "at2200a.h"

#define ALIAS_LCP	100
#define ALIAS_TCS	200

enum ts { undefined = 0, elenco = 1, etichette = 2 };

// definizione form per etichette
class TEti_pereta_form : public TForm
{
public:
	
	virtual TCursor* cursor() const;
	virtual TRelation* relation() const;
	TPrint_section& get_body() { return section('B'); } ;
  TEti_pereta_form(): TForm() {};
  TEti_pereta_form(const char* form, const char * code = "", int editlevel = 0, const char* desc = "")
    						: TForm(form,code,editlevel,desc) {};
  virtual ~TEti_pereta_form() {};
};

class TPereta_application : public TPrintapp
{
  static bool filter_func_pereta(const TRelation *);

  TRelation*        _rel;
  TMask*            _msk;
  TEti_pereta_form*	_form_eti;
  
  TAssoc_array*			_categorie;
  
  int 							_cur1, _cur2, _cur3, _cur4;
  TParagraph_string _cognome_nome, _dencom;
  
  TDate 						_data_stampa;
  TDate							_dataini, _datafin;
  ts								_tipo_stampa;
  TString 					_codsez, _codsot;
  
  
protected:
  virtual bool user_create();
  virtual bool user_destroy();
  virtual bool set_print(int m);
  virtual void set_page(int file, int cnt);
  virtual bool preprocess_page (int file, int counter);

public:
	void set_one_cat(short field_id);
	void set_categorie();
	TAssoc_array& get_categorie() { return *_categorie; }
  void crea_intestazione();
  void filtra_sezioni();
  void header_sezione(const char* codsez, const char* codsot);
  TMask& app_mask() { return *_msk; }

  TPereta_application() : _data_stampa(TODAY), _cognome_nome("",25), _dencom("",50) {}
};

HIDDEN inline TPereta_application& app() { return (TPereta_application&) main_app(); }

TCursor* TEti_pereta_form::cursor() const { return app().current_cursor(); }

TRelation* TEti_pereta_form::relation() const { return cursor()->relation(); }

void TPereta_application::filtra_sezioni()
{
 	const char* sezini = _msk->get(F_SEZINI);
 	const char* sotini = _msk->get(F_SOTINI);
 	const char* sezfin = _msk->get(F_SEZFIN);
 	const char* sotfin = _msk->get(F_SOTFIN);
  select_cursor(_cur4); 
  TLocalisamfile& fl = current_cursor()->file(LF_SOGGETTI);
  TRectype da(fl.curr());
  TRectype a(fl.curr());   
  da.zero();
  a.zero();
  //if ((sezini.not_empty()) && (sezini.ok()))
	if (sezini != NULL)  
		da.put(SOG_CODSEZ, sezini);
  //if ((sotini.not_empty()) && (sotini.ok()))    	
  if (sotini != NULL)
		da.put(SOG_CODSOT, sotini);
  //if ((sezfin.not_empty()) && (sezfin.ok()))
  if (sezfin != NULL)
		a.put(SOG_CODSEZ, sezfin);
  //if ((sotfin.not_empty()) && (sotfin.ok()))    	
  if (sotfin != NULL)
		a.put(SOG_CODSOT, sotfin);
	current_cursor()->setregion(da, a);
}	

void TPereta_application::set_page(int file, int cnt)
{
	switch (_tipo_stampa)
	{
		case etichette:
		{
			TPrint_section& corpo = _form_eti->get_body();
			corpo.reset();
			corpo.update();
  		for (int i = 0; i < corpo.height(); i++)
  		{
  			TPrintrow& riga = corpo.row(i);
  			set_row(i+1,riga);
			}  			
			force_setpage(TRUE);	// serve perchè alla prossima etichetta rifaccia la setpage
														// altrimenti stampa sempre la stessa etichetta
		}
		break;
		case elenco:
		{
			set_row(1,"@0g@pn", FLD(LF_SOGGETTI,SOG_CODICE,"######"));
			set_row(1,"@7g@S", FLD(LF_SOGGETTI,SOG_CATDON));
			set_row(1,"@10g#a", &_cognome_nome);
			set_row(1,"@36g@ld", FLD(LF_SOGGETTI,SOG_DATANASC));
			set_row(1,"@47g@S", FLD(LF_SOGGETTI,SOG_INDIRIZZO));
			set_row(1,"@98g@S", FLD(LF_SOGGETTI,SOG_TELABI));
			set_row(1,"@114g@S", FLD(LF_SOGGETTI,SOG_TELLAV));
			set_row(2,"@47g#a", &_dencom);
			set_row(2,"@114g@S", FLD(LF_SOGGETTI,SOG_TELALT));
		}
		break;					
	}	
}

bool TPereta_application::filter_func_pereta(const TRelation * rel)
{   
	bool filtrato = TRUE;
	
	TLocalisamfile*      sog = &(rel->lfile(LF_SOGGETTI)); 
  
	//filtro per categorie
	TAssoc_array& categorie = TPereta_application::get_categorie();
	if (categorie.items() != 0)
	{
		const char* cat = sog->curr().get(SOG_CATDON);
		if (categorie.is_key(cat))
			filtrato = TRUE;
		else
			filtrato = FALSE;	
	}	
	if (filtrato)		
	{
		// filtro per età
  	TRectype from (sog->curr());
  	TRectype to (sog->curr());
  	from.zero();
  	to.zero();
  	if (app()._dataini.ok())
    	from.put(SOG_DATANASC, app()._dataini);
  	if (app()._datafin.ok())
    	to.put(SOG_DATANASC, app()._datafin);
  	if ((sog->curr() >= from) && (sog->curr() <= to))
    	filtrato = TRUE;
    else
    	filtrato = FALSE;	
  }  	
  return filtrato;
}

bool TPereta_application::preprocess_page(int file, int counter)
{
	// contatore soggetti stampati
	// per ora non c'è
	if (_tipo_stampa == elenco)
	{
		TString nome = current_cursor()->curr().get(SOG_COGNOME);
		nome << " ";
		nome << current_cursor()->curr().get(SOG_NOME);
		_cognome_nome = nome;
		TString localita = "";
		localita << current_cursor()->curr(-ALIAS_LCP).get("S6");
		if (localita.not_empty() && localita.ok())
		{
			localita << " ";
			localita << current_cursor()->curr(-ALIAS_LCP).get("S0");
			localita << " - ";		
		}
		else
		{
			localita = current_cursor()->curr(LF_COMUNI).get(COM_CAPCOM);
			localita << " ";
		}			
		localita << current_cursor()->curr(LF_COMUNI).get(COM_DENCOM);
		localita.trim();
		_dencom = localita;

		// salto pagina se cambio sezione
		TString codsez = current_cursor()->curr().get(SOG_CODSEZ);		
		TString codsot = current_cursor()->curr().get(SOG_CODSOT);		
		if ((_codsez!=codsez)||(_codsot!=codsot))
		{
			if (_codsez != "**")
				printer().formfeed();
			_codsez = codsez;
			_codsot = codsot;
			header_sezione(codsez, codsot);
		}
	}		
  return TRUE;
}

void TPereta_application::header_sezione(TString codsez, TString codsot)
{
	const char* densez = current_cursor()->curr(LF_SEZIONI).get(SEZ_DENSEZ);
	const char* densot = current_cursor()->curr(LF_SEZIONI).get(SEZ_DENSOT);
	TString intestazione(132);
	intestazione = "Sezione: ";
	intestazione << codsez;
	intestazione << "/";
	intestazione << codsot;
	intestazione << " ";
	intestazione << densez;
	if ((densot.ok())&& (densot.not_empty()))
	{
		intestazione << "/";
		intestazione << densot;
	}		
	intestazione.center_just();
	set_header(1,"@0g%s", (const char*) intestazione);
	return;
}

bool TPereta_application::set_print(int)
{
	_tipo_stampa = undefined;
  KEY tasto;
  tasto = _msk->run();
  switch (tasto)
  {
  case F_ELENCO:
  	_tipo_stampa = elenco;
  	_codsez = "**";
  	_codsot = "**";
  	break;
  case F_ETICHETTE:
  	_tipo_stampa = etichette;	
  	break;
  }	
	if (_tipo_stampa != undefined)
  {
    reset_files(); 
    add_file(LF_SOGGETTI);
    _dataini = _msk->get(F_DATAINI);
    _datafin = _msk->get(F_DATAFIN);
		filtra_sezioni();
		set_categorie();
		current_cursor()->set_filterfunction (filter_func_pereta);
		reset_print();
    crea_intestazione();
    return TRUE;
  }
  else
    return FALSE;
}

void TPereta_application::set_one_cat(short field_id)
{
	const char* cat = _msk->get(field_id);
	if (cat != NULL)
		_categorie->add(cat);
}

void TPereta_application::set_categorie()
{
	set_one_cat(F_CAT1);
	set_one_cat(F_CAT2);
	set_one_cat(F_CAT3);
	set_one_cat(F_CAT4);
	set_one_cat(F_CAT5);
	set_one_cat(F_CAT6);
}

void TPereta_application::crea_intestazione()
{
  reset_header();
  
  if (_tipo_stampa == elenco)
  {
  	TString sep(132);
  	sep = "ELENCO PER DATA DI NASCITA";
  	TDate data = _msk->get(F_DATAINI);
  	if (data.ok())
  	{
  		sep << " dal ";
  		sep << data.string();
		}
  	data = _msk->get(F_DATAFIN);
  	if (data.ok())
  	{
  		sep << " al ";
  		sep << data.string();
		}
		sep.center_just();
  	set_header(2, "@0g%s", (const char*) sep);
  	TString data_stampa = _data_stampa.string();
  	set_header(2,"@0g%10s", (const char*) data_stampa);
  	sep = "";
  	sep << "Pag. @#";
  	set_header(2, "@120g%s", (const char*) sep);  
  	
  	sep = "";
  	sep.fill('-');
  	set_header(3, (const char *) sep);
  
  	set_header(4,"@0gCod.@7gC.@10gCognome e nome@36gNato il@47gIndirizzo@98gTelefono abit.@114gTelefono lavoro");
  	set_header(5,"@47gCAP/Località/Comune/Prov.@114gTelefono altro");
  	set_header(6,"@0g------@7g--@10g-------------------------@36g----------@47g--------------------------------------------------@98g---------------@114g---------------");
	}  	
}

bool TPereta_application::user_create()
{
  _rel = new TRelation(LF_SOGGETTI);
  _rel->add("TCS", "CODTAB==STATO",1,0,ALIAS_TCS);
  _rel->add("LCP", "CODTAB==LOCALITA",1,0,ALIAS_LCP);
  _rel->add(LF_COMUNI, "COM==COM");
  // per stampare nell'intestazione la denominazione della sezione
  _rel->add(LF_SEZIONI, "CODSEZ==CODSEZ|CODSOT==CODSOT");

  _cur1 = add_cursor(new TCursor(_rel, "", 1));	//cursore ordinamento per codice
  _cur2 = add_cursor(new TCursor(_rel, "", 2));	//cursore ordinamento per cognome e nome
  _cur3 = add_cursor(new TCursor(_rel, "", 3));	//cursore ordinamento per sezione+sottogruppo+codice
  _cur4 = add_cursor(new TCursor(_rel, "", 4));	//cursore ordinamento per sezione+sottogruppo+cognome e nome

	_form_eti = new TEti_pereta_form("AT_ETSOG");
  _msk = new TMask("at2200a");
  return TRUE;
}

bool TPereta_application::user_destroy()
{
  delete _msk;
  delete _rel;
  delete _form_eti;
  return TRUE;
}

int at2200(int argc, char* argv[])
{

  TPereta_application a;

  a.run(argc, argv, "Elenco per data nascita");

  return 0;
}
